//create-base64-eml

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <mbstring.h>

#define APPNAME "cb64 beta 1"

typedef unsigned char uchar;

const uchar b64tbl[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

//gqMIMȆΉ\
uchar *mime_table[][2] = {
	{".jpg", "image/jpeg"},
	{".jpeg", "image/jpeg"},
	{".gif", "image/gif"},
	{".png", "image/png"},
	{".bmp", "image/bmp"},
	{".txt", "text/plain"},
	{".htm", "text/html"},
	{".wav", "audio/wav"},
	{".mp3", "audio/mp3"},
	{".zip", "application/x-zip-compressed"},
	{NULL, "application/octet-stream"}
};

//t@CMIME^Cv擾
int getmime(const uchar *filename, uchar *mime)
{
	int n = 0;
	uchar ext[32];
	
	if (filename == NULL || mime == NULL) return 0;
	
	_splitpath(filename, NULL, NULL, NULL, ext);
	while(mime_table[n][0]) {
		if (strcmp(mime_table[n][0], ext) == 0) {
			break;
		}
		n++;
	}
	strcpy(mime, mime_table[n][1]);
	return 1;
}

//^CX^v
int gettimestamp(uchar *s, int smax)
{
	time_t tim;
	struct tm *tp;
	
	if (time(&tim) == -1) return 0;
	tp = localtime(&tim);
	
	strftime(s, smax, "%a, %d %b %Y %H:%M:%M +0900", tp);
	
	return 1;
}

//t@CJbufɕԂBbuf͌ĂяomallocȂƁB܂gpfree邱ƁB
long readfile(const uchar *file, uchar **buf)
{
	FILE *fp;
	long siz;
	
	fp = fopen(file, "rb");
	if (fp == NULL) return 0;
	
	fseek(fp, 0, SEEK_END);
	siz = ftell(fp);
	rewind(fp);
	
	*buf = malloc(siz + 1);
	fread(*buf, 1, siz, fp);
	fclose(fp);
	return siz;
}

// lenoCg̃f[^srcbase64GR[hdstɓ(dst͏\ȃwĂ邱ƁB)
//̃R[h̒쌠Masanao Izumoɂ܂B
//Copyright (C) 1999 Masanao Izumo <iz@onicos.co.jp>
//URL = http://www.onicos.com/staff/iz/amuse/javascript/expert/base64.txt
int b64encode(uchar *src, int len, uchar *dst)
{
	int i, j;
	int c1, c2, c3;

	i = j = 0;
	
	while (i < len) {
		c1 = src[i] & 0xff;
		i++;
		if (i == len) {
			dst[j  ] = b64tbl[c1 >> 2];
			dst[j+1] =  b64tbl[(c1 & 0x3) << 4];
			dst[j+2] = '=';
			dst[j+3] = '=';
			j += 4;
			break;
		}
		c2 = src[i];
		i++;
		if (i == len) {
			dst[j  ] = b64tbl[c1 >> 2];
			dst[j+1] = b64tbl[((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4)];
			dst[j+2] = b64tbl[(c2 & 0xF) << 2];
			dst[j+3] = '=';
			j += 4;
			break;
		}
		c3 = src[i];
		i++;
		dst[j  ] = b64tbl[c1 >> 2];
		dst[j+1] = b64tbl[((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4)];
		dst[j+2] = b64tbl[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)];
		dst[j+3] = b64tbl[c3 & 0x3F];
		j += 4;

	}
	dst[j] = 0;
	return j;
}

//t@Cb64GR[hfpɏo
int writeb64(const uchar *fnam, FILE *fp, uchar *beginboundary)
{
	uchar *src;
	uchar *dst;
	uchar *p;
	uchar fnam2[260];
	uchar mimestr[32];

	int srclen, dstlen, n;

	//t@Cǂݍ
	srclen = readfile(fnam, &src);
	if (srclen == 0) {
//		puts("t@CJ");
		return 0;
	}
	dst = malloc(srclen * 1.4);

	dstlen = b64encode(src, srclen, dst);//base64GR[h
	if (dstlen == 0) {
//		puts("GR[hG[");
		return 0;
	}
	
	
	getmime(fnam, mimestr);//MIME擾
	
	//t@Co
	p = strrchr(fnam, '\\');
	if (p == NULL) {
		strcpy(fnam2, fnam);
	} else {
		strcpy(fnam2, p+1);
	}
	
	//wb_
	fprintf(fp, 
		"%s\r\n"
		"Content-Type: %s;\r\n"
		"\tname=\"%s\"\r\n"
		"Content-Transfer-Encoding: base64\r\n"
		"Content-Disposition: attachment;\r\n"
		"\tfilename=\"%s\"\r\n"
		"\r\n"
		, beginboundary, mimestr, fnam2, fnam2);


	//
	for (n=0; n<dstlen; n++) {
		fputc(dst[n], fp);
		if (n % 76 == 75) fprintf(fp, "\r\n");
	}
	fprintf(fp, "\r\n");
	
	free(src);
	free(dst);

	return dstlen;
}

/*
sjisjisɕϊB

̊֐́AȂΎ̃TCgAvO~OFX(http://7ujm.net/)̒ɂA
http://7ujm.net/C++/SJIStoJIS.htmlSJIS_JIS֐ςĂ܂B
*/

void sjis2jis(uchar *sjis, uchar *jis){
	unsigned int i=0;
	int ConFlag=0;
	int iLen;
	const uchar KI[] = {0x1B, 0x24, 0x42, 0};
	const uchar KO[] = {0x1B, 0x28, 0x42, 0};
	uchar buff[3];
	
	jis[0] = 0;
	iLen = strlen(sjis)-1;

	while(i<iLen){
		if(_ismbblead(sjis[i])){//}`oCg𔻒
			if(!ConFlag){//}`oCg̊Jn
				strcat(jis, KI);
				ConFlag=1;
			}
		}else{
			if(ConFlag){//ASCII̊Jn
				strcat(jis, KO);
				ConFlag=0;
			}
		}
		if(ConFlag){
			//QoCg̕ϊ
			unsigned short f;
			f =_mbcjmstojis(MAKEWORD(sjis[i+1], sjis[i]));
			buff[0]=HIBYTE(f);
			buff[1]=LOBYTE(f);
			buff[2]=0;
			strcat(jis, buff);
			i+=2;
		}else{
			//QoCgȊO͂̂܂܃Rs[
			buff[0]=sjis[i];
			buff[1] = 0;
			strcat(jis, buff);
			i++;
		}
	}
	if(ConFlag){//ŌASCII̊Jn݂܂
		strcat(jis, KO);
	}
}

void usage(void)
{
	
	printf(
		APPNAME " G摜eml`ɕϊ"
		"\n"
		"g : cb64 t@C...\n"
		"\n"
	);
	
	puts("ENTERŏI܂B");
	getchar();
	exit(0);
}

main(int argc, uchar *argv[])
{
	FILE *fp;
	uchar outfile[300], outfilename[300];
	uchar boundary[100];
	uchar beginboundary[100];
	uchar endboundary[100];
	uchar address[500];//[address
	uchar subject[500];//薼
	uchar timestamp[300];//^CX^v

	uchar header[5000];//wb_
	
	uchar buf1[500],  buf2[500];
	uchar *p;
	int l;
		FILETIME ft;
	SYSTEMTIME st;
	if (argc == 1) usage();

	sprintf(boundary, "o(^-^)o");
	sprintf(beginboundary, "--%s", boundary);
	sprintf(endboundary, "--%s--", boundary);

	
	GetModuleFileName(NULL, buf1, MAX_PATH );
	p = strrchr(buf1, '\\');//K\T
	if (p != NULL) *p=0;

	//o̓t@C
	GetLocalTime(&st);
	SystemTimeToFileTime(&st, &ft);
	sprintf(outfilename, "u6b-pid%u_%u-%u.eml",GetCurrentProcessId(), ft.dwHighDateTime, ft.dwLowDateTime);
	sprintf(outfile, "%s\\%s", buf1, outfilename);
	
	//[AhX
	sprintf(buf1, "\"VqD\"");
	sjis2jis(buf1, buf2);
	l = b64encode(buf2, strlen(buf2), buf1);
	sprintf(address, "=?iso-2022-jp?B?%s?= <tokuzawa-naoko@daisuki.desu>", buf1);

	//薼
	sprintf(buf1, "VqD");
	sjis2jis(buf1, buf2);
	l = b64encode(buf2, strlen(buf2), buf1);
	sprintf(subject, "=?iso-2022-jp?B?%s?=", buf1);
	
	gettimestamp(timestamp, 300);//^CX^v
	
	sjis2jis("̃G摜[" APPNAME "ō쐬܂B" , buf1);//{

	sprintf(header, 
		"From: %s\r\n"
		"To: %s\r\n"
		"Subject: %s\r\n"
		"Date: %s\r\n"
		"MIME-Version: 1.0\r\n"
		"Content-Type: multipart/mixed;\r\n"
		"\tboundary=\"%s\"\r\n"
		"\r\n"
		"This is a multi-part message in MIME format.\r\n"
		"\r\n"
		"%s\r\n"
		"Content-Type: text/plain;\r\n"
		"\tformat=flowed;\r\n"
		"\tucharset=\"ISO-2022-jp\";\r\n"
		"\treply-type=original\r\n"
		"Content-Transfer-Encoding: 7bit\r\n"
		"\r\n"
		"%s\r\n"
		, address, address, subject, timestamp, boundary, beginboundary, buf1);

	//o̓t@CJ
	fp = fopen(outfile, "wb");
	if (fp == NULL) {
		puts("t@CJ");
		return -1;
	}
	
	printf("G摜[[%s]쐬...\n\n", outfilename);

	
	fputs(header, fp);
	
	//̃t@CGR[hď
	while (--argc) {
		int len;
		
		//t@Co
		p = strrchr(argv[argc], '\\');
		if (p == NULL) {
			printf("%s ...", argv[argc]);
		} else {
			printf("%s ...", p+1);
		}
		
		//base64GR[hя
		len = writeb64(argv[argc], fp, beginboundary);
		if (len != 0) {
		 	printf("\b\b\b(%1.1fKB) OK\n", len/1024.f);
		} else {
			printf(" NG\n");
		}
	}
	
	//I
	fprintf(fp, "\r\n%s\r\n", endboundary);
	
	l = ftell(fp);
	
	fclose(fp);
	
	printf("\nt@CTCY:%1.1fKB\n", l/1024.);
	puts("܂BENTERŏI܂B");
	getchar();
	exit(0);
	
}
